PROGRAM Main
VAR

    astrDisplayText_20x4        : ARRAY [1..4] OF STRING(20) := [   (* |--------------------| *)
                                                                       'SYS TEC electronic'  ,
                                                                       'PLCcore-F407'        ,
                                                                       'I2C LCD Driver Demo' ,
                                                                       '20x4 Characters'
                                                                ];

    FB_Lcd_Initialize           : Lcd_Initialize;
    FB_Lcd_ClearScreen          : Lcd_ClearScreen;
    FB_Lcd_WriteString          : Lcd_WriteString;

    I2cHandle                   : HI2C;
    usiDisplayLineIdx           : USINT;

    xConfirm                    : BOOL;
    usiError                    : USINT;

    iProcState                  : INT               := 0;



END_VAR


    CASE iProcState OF

    (* ------------------------------------------------------------------------------------ *)
    (*  Initialize LCD Driver                                                               *)
    (* ------------------------------------------------------------------------------------ *)

    0:  FB_Lcd_Initialize (xEnable_i := FALSE);    
        iProcState := iProcState + 1;

    1:
        FB_Lcd_Initialize (
            xEnable_i := TRUE
            |
            I2cHandle := I2cHandle_o,
            xConfirm  := xConfirm_o,
            usiError  := usiError_o);

        IF (xConfirm = TRUE) THEN
            iProcState := iProcState + 1;
            RETURN;
        END_IF;
        
        IF (usiError <> 0) THEN
            iProcState := -1;
        END_IF;


    (* ------------------------------------------------------------------------------------ *)
    (*  Clear Screen                                                                        *)
    (* ------------------------------------------------------------------------------------ *)

    2:  FB_Lcd_ClearScreen (xEnable_i := FALSE);    
        iProcState := iProcState + 1;

    3:
        FB_Lcd_ClearScreen (
            xEnable_i   := TRUE,
            I2cHandle_i := I2cHandle
            |
            xConfirm    := xConfirm_o,
            usiError    := usiError_o);

        IF (xConfirm = TRUE) THEN
            usiDisplayLineIdx := 1;
            iProcState := iProcState + 1;
            RETURN;
        END_IF;
        
        IF (usiError <> 0) THEN
            iProcState := -1;
        END_IF;


    (* ------------------------------------------------------------------------------------ *)
    (*  Write String                                                                        *)
    (* ------------------------------------------------------------------------------------ *)

    4:  FB_Lcd_WriteString (xEnable_i := FALSE);    
        iProcState := iProcState + 1;

    5:
        FB_Lcd_WriteString (
            xEnable_i   := TRUE,
            I2cHandle_i := I2cHandle,
            usiLine_i   := usiDisplayLineIdx,
            strText_i   := astrDisplayText_20x4[usiDisplayLineIdx]
            |
            xConfirm    := xConfirm_o,
            usiError    := usiError_o);

        IF (xConfirm = TRUE) THEN
            IF (usiDisplayLineIdx < 4) THEN
                usiDisplayLineIdx := usiDisplayLineIdx + 1;
                iProcState := iProcState - 1;
            ELSE
                iProcState := iProcState + 1;
            END_IF;
            RETURN;
        END_IF;
        
        IF (usiError <> 0) THEN
            iProcState := -1;
        END_IF;






    (* ------------------------------------------------------------------------------------ *)
    (*  Finish                                                                              *)
    (* ------------------------------------------------------------------------------------ *)

    6:  (* ---- Finish ---- *)
        RETURN;


    (* ------------------------------------------------------------------------------------ *)
    (*  Error                                                                               *)
    (* ------------------------------------------------------------------------------------ *)

    -1:  (* ---- Error ---- *)
        RETURN;

    ELSE
        RETURN;

    END_CASE;




    RETURN;



END_PROGRAM