// PortNumExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PortNumExample.h"
#include "PortNumExampleDlg.h"
#include "CP210xManufacturingDLL.h"
#include <string.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPortNumExampleDlg dialog

CPortNumExampleDlg::CPortNumExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPortNumExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPortNumExampleDlg)
	m_Data = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPortNumExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPortNumExampleDlg)
	DDX_Text(pDX, IDC_EDIT_DATA, m_Data);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPortNumExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CPortNumExampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPortNumExampleDlg message handlers

BOOL CPortNumExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Init. member variables
	m_hUSBDevice = INVALID_HANDLE_VALUE;
	
	// Get devices, init. combo box with their names
	FillDeviceList();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPortNumExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPortNumExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPortNumExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CPortNumExampleDlg::FillDeviceList()
{
	EnumDevices();
	GetDeviceData();
}


void CPortNumExampleDlg::EnumDevices()
{
	//Obtain the number of connected devices
	CP210x_STATUS status = CP210x_GetNumDevices(&m_dwNumDevices);
}


void CPortNumExampleDlg::GetDeviceData()
{
	UpdateData(TRUE);

	//Variables to store Vid, Pid and SerialNumbers
	WORD Vid, Pid;
	CP210x_SERIAL_STRING serialNum;

	//Reset m_Data to blank since we are retrieving new device data
	//Whenever we have new information to show, the string will be
	//added onto this variable.
	m_Data = "";

	//Loop through and display data for each connected device
	for (int i = 0; i < m_dwNumDevices; i++)
	{
		// Query the Vid, Pid and Serial number of each device.
		// We will use this information to look up the device
		// in the registry to find the port number. There are also
		// examples of displaying other items in the registry as well.

		// Open device
		CP210x_STATUS status = CP210x_Open(i, &m_hUSBDevice);
		if (status == CP210x_SUCCESS)
		{
			// Get Vid
			status = CP210x_GetDeviceVid(m_hUSBDevice, &Vid);
			if (status == CP210x_SUCCESS)
			{
				// Get Pid
				status = CP210x_GetDevicePid(m_hUSBDevice, &Pid);
				if (status == CP210x_SUCCESS)
				{
					BYTE bLength = 0;
					CString tmpDevStr;

					// Get Serial Number
					status = CP210x_GetDeviceSerialNumber(m_hUSBDevice, serialNum, &bLength);

					// Null terminate to make it a string
					serialNum[bLength] = '\0';

					//Display our current information about the device we found
					tmpDevStr.Format("Found Device: VID=%04X, PID=%04X", Vid, Pid);

					m_Data += tmpDevStr;
					m_Data += 0xD;
					m_Data += 0xA;
					m_Data += "           Serial Num=";
					m_Data += serialNum;
					m_Data += 0xD;
					m_Data += 0xA;
				}
			}
		}

		// This is a function call to obtain the port number
		// by passing the Vid, Pid, and SN of the device in
		// question. An integer value with the port is passed back
		int Port;
		DWORD winVersion = GetVersion() & VERSION_MASK;
		
		if ((winVersion == VERSION_WINXP2000) || (winVersion == VERSION_WINVISTA))
			Port = GetPortNumXP2000Vista(Vid, Pid, serialNum);
		else if (winVersion == VERSION_WIN98)
			Port = GetPortNum98(Vid, Pid, serialNum);

		// Text formatting for display of the com port
		char* tmpPortString;
		tmpPortString = new char[10];
		m_Data += "This device is on COM Port: ";
		m_Data += itoa(Port, tmpPortString, 10);
		m_Data += 0xD;
		m_Data += 0xA;

		delete tmpPortString;

		//Close the USB Device
		CP210x_Close(m_hUSBDevice);

		m_Data += 0xD;
		m_Data += 0xA;
		m_Data += 0xD;
		m_Data += 0xA;
	}

	UpdateData(FALSE);
}


// GetPortNum functions takes the Vid, Pid, and SerialNumber and
// returns an integer containing the COM port that the device is
// connected to (different functions for Win98/WinXP2000Vista)

int CPortNumExampleDlg::GetPortNumXP2000Vista(WORD vid, WORD pid, char* ser)
{
	//Variables used for Registry access
	HKEY tmpKey, tmpSubKey, tmpPortKey;
	CString portKeyString;
	DWORD valtype;
	char* portString;
	DWORD length = 100;
	portString = new char[101];

	//Set portnum to -1, so if there is an error we will
	//know by returning a negative port value
	int portNum = -1;

	//  Open keys to get to the key where the port number is located. This key is:
	//  HKLM\System\CurrentControlSet\Enum\USB\Vid_xxxx&Pid_yyyy&Mi_00\zzzz_00\DeviceParameters\PortName
	if (ERROR_SUCCESS == RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\", 0, KEY_READ, &tmpKey))
	{
		if (ERROR_SUCCESS == RegOpenKey(tmpKey, "Enum\\USB\\", &tmpSubKey))
		{
			//Loop through and replace spaces for WinXP2000Vista
			int i = 0;
			while (ser[i] != '\0')
			{
				if (ser[i] == 0x20)
					ser[i] = '_';
				i++;
			}

			//The portkey string should look like this
			//"Vid_XXXX&Pid_XXXX&MI_00\\XXXX_00" where the XXXX's are Vid, Pid and serial string - version less than 5.0
			//"Vid_XXXX&Pid_XXXX\\XXXX" where the XXXX's are Vid, Pid and serial string - version greater than or equal to 5.0
			portKeyString.Format("Vid_%04x&Pid_%04x&Mi_00\\%s_00\\Device Parameters\\", vid, pid, ser);

			//If the portkey string is in the registry, then go ahead and open the portname
			if (ERROR_SUCCESS == RegOpenKeyEx(tmpSubKey, portKeyString, 0, KEY_READ, &tmpPortKey))
			{
				if (ERROR_SUCCESS == RegQueryValueEx(tmpPortKey, "PortName", NULL, &valtype, (unsigned char *)portString, &length))
				{
					// When we obtain this key, it will be in string format of
					// "COMXX" where XX is the port. Simply make the first three
					// elements of the string 0, and call the atoi function to obtain
					// the number of the port.
					portString[0] = '0';
					portString[1] = '0';
					portString[2] = '0';
					portNum = atoi(portString);
				}
				//Make sure to close all open keys for cleanup
				RegCloseKey(tmpPortKey);
			}
			else
			{
				portKeyString.Format("Vid_%04x&Pid_%04x\\%s\\Device Parameters\\", vid, pid, ser);

				//If the portkey string is in the registry, then go ahead and open the portname
				if (ERROR_SUCCESS == RegOpenKeyEx(tmpSubKey, portKeyString, 0, KEY_READ, &tmpPortKey))
				{
					if (ERROR_SUCCESS == RegQueryValueEx(tmpPortKey, "PortName", NULL, &valtype, (unsigned char *)portString, &length))
					{
						// When we obtain this key, it will be in string format of
						// "COMXX" where XX is the port. Simply make the first three
						// elements of the string 0, and call the atoi function to obtain
						// the number of the port.
						portString[0] = '0';
						portString[1] = '0';
						portString[2] = '0';
						portNum = atoi(portString);
					}
					//Make sure to close all open keys for cleanup
					RegCloseKey(tmpPortKey);
				}
			}

			RegCloseKey(tmpSubKey);
		}
		RegCloseKey(tmpKey);
	}
	RegCloseKey(HKEY_LOCAL_MACHINE);

	delete portString;

	// Return the number of the port the device is connected too
	return portNum;
}

int CPortNumExampleDlg::GetPortNum98(WORD vid, WORD pid, char* ser)
{
	//Variables used for Registry access
	HKEY tmpKey;
	CString portKeyString, serKeyString;
	int	serialIndex;
	DWORD valtype;
	char* portString;
	DWORD length = 100;
	portString = new char[101];

	//Set portnum to -1, so if there is an error we will
	//know by returning a negative port value
	int portNum = -1;

	//We will search through the keys by index, starting at 0
	//Use this index in the key "Enum\SLABCR\guid\XXXX"
	serialIndex = 0;
	serKeyString.Format("Enum\\SLABCR\\guid\\%.4d", serialIndex);

	//Loop through and convert the serial string to all upper case and replace spaces for Win98
	int i = 0;
	while (ser[i] != '\0')
	{
		if (ser[i] == 0x20)
			ser[i] = '_';
		else if ((ser[i] >= 0x61) && (ser[i] <= 0x7A))
			ser[i] -= 32;
		i++;
	}

	//The portkey string should look like this when we query the CLowerDeviceID
	//"USB\VID_XXXX&PID_XXXX&MI_00\\XXXX_00" where the XXXX's are Vid, Pid and serial string
	portKeyString.Format("USB\\VID_%04X&PID_%04X&MI_00\\%s_00", vid, pid, ser);

	//  Open keys to get to the key where the port number is located. This key is:
	//  HKLM\Enum\SLABCR\guid\XXXX\Portname is the key and we will loop through each key in the registry
	while (ERROR_SUCCESS == RegOpenKey(HKEY_LOCAL_MACHINE, serKeyString, &tmpKey))
	{	
		// Determine the status of the call
		DWORD status = RegQueryValueEx(tmpKey, "CRLowerDeviceID", NULL, &valtype, (unsigned char *)portString, &length);

		// If we need to make the call again, then decrement the serial index so we can access
		// it the next time through the loop
		if (ERROR_MORE_DATA == status)
			serialIndex--;
		// Otherwise, the call is a success, and we can compare the portString from the key
		// to the port string that we want, if they match then retrieve the port
		else if (ERROR_SUCCESS == status)
		{
			if (portString == portKeyString)
			{
				if (ERROR_SUCCESS == RegQueryValueEx(tmpKey, "Portname", NULL, &valtype, (unsigned char *)portString, &length))
				{
					// When we obtain this key, it will be in string format of
					// "COMXX" where XX is the port. Simply make the first three
					// elements of the string 0, and call the atoi function to obtain
					// the number of the port.
					portString[0] = '0';
					portString[1] = '0';
					portString[2] = '0';
					portNum = atoi(portString);
				}
			}
		}

		// Increment the serial index
		serialIndex++;
		serKeyString.Format("Enum\\SLABCR\\guid\\%.4d", serialIndex);
						
		//Make sure to close all open keys for cleanup
		RegCloseKey(tmpKey);
	}
	RegCloseKey(HKEY_LOCAL_MACHINE);

	delete portString;

	// Return the number of the port the device is connected too
	return portNum;
}

void CPortNumExampleDlg::OnRefresh() 
{
	// TODO: Add your control notification handler code here

	FillDeviceList();	
}
